﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls;
using System.Windows;
using Prism.Commands;

namespace HandleAddingNewDataItemCommand
{
    public class MyViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private ObservableCollection<Club> clubs;
        private object selectedItem;
        private void handleAddingNewRecordToDevicesGrid(object parameter)
        {
            MessageBox.Show("Entered HandleAddingNewRecordToDevicesGridCommand!");
            // Get RadGridView that is sender.
            Telerik.Windows.Controls.RadGridView gridView =
                ((parameter as GridViewAddingNewEventArgs).OwnerGridViewItemsControl) as Telerik.Windows.Controls.RadGridView;
            // Get new item inserted in the RadGridView.
            Telerik.Windows.Controls.GridViewDataColumn newItem =
                ((parameter as GridViewAddingNewEventArgs).NewObject) as Telerik.Windows.Controls.GridViewDataColumn;
            // Prepair to select this new item in the RadGridView.
            Telerik.Windows.Controls.GridViewDataColumn[] aItem = { newItem };
            System.Collections.IEnumerable selectedItem = aItem;
            // Select the new item in the RadGridView.
            gridView.Select(selectedItem);
        }

        public MyViewModel()
        {
            this.HandleAddingNewRecordToDevicesGridCommand = new DelegateCommand<object>(this.handleAddingNewRecordToDevicesGrid);
        }

        public DelegateCommand<object> HandleAddingNewRecordToDevicesGridCommand { get; private set; }

        public ObservableCollection<Club> Clubs
        {
            get
            {
                if (this.clubs == null)
                {
                    this.clubs = Club.GetClubs();
                }

                return this.clubs;
            }
        }

        public object SelectedItem
        {
            get { return this.selectedItem; }
            set
            {
                if (value != this.selectedItem)
                {
                    this.selectedItem = value;
                    this.OnPropertyChanged("SelectedItem");
                }
            }
        }

        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
